from Globals import ImageFile
import VirtualHostFolder
import ZPublisher.HTTPRequest

def initialize(context):


    context.registerClass(
        VirtualHostFolder.VirtualHostFolder,
        constructors=(VirtualHostFolder.manage_addVirtualHostFolderForm,
                      VirtualHostFolder.manage_addVirtualHostFolder),
        icon='www/VHFolder_icon.gif'
        )

    # context.registerBaseClass(VirtualHostFolder.VirtualHostFolder)

    context.registerHelp()
    context.registerHelpTitle('Virtual Host Folder')

misc_ = {'host'   : ImageFile('www/host_icon.gif', globals()),
         'alias'  : ImageFile('www/alias_icon.gif', globals()) } # ,
         #'top'    : ImageFile('www/top.gif', globals()),
         #'bottom' : ImageFile('www/bottom.gif', globals())}

def setAliasFolder(self, aliasName):
    """ Clean the request to hide an alias object forced in the path """
    #other = self.other
    #parents=self.PARENTS
    #self.set("PARENTS_AT_FIRST_SET", [(hasattr(x,"getId") and x.getId() or hasattr(x, "id") and (callable(x.id) and x.id() or x.id) or hasattr(x, "__name__") and x.__name__ or x) for x in parents[:]])
    #self.set("PARENTS_NOW",self.PARENTS)
    _steps=self._steps
    #self.set("_STEPS_SO_FAR",_steps[:])
    del _steps[-2:]
    _steps.append(aliasName)
    #self.set("_ADJUSTED_STEPS",_steps[:])
    #self.set("_FINAL_STEPS",_steps)
    steps=self.steps
    #self.set("STEPS_SO_FAR",steps[:])
    steps.pop()
    #self.set("ADJUSTED_STEPS",steps[:])
    #self.set("FINAL_STEPS",steps)
    self._resetURLS()

def setAliasName(self, aliasName):
    "Does the rest of the job (not a lot)"
    #parents=self.PARENTS
    #self.set("PARENTS_AT_SECOND_SET", [(hasattr(x,"getId") and x.getId() or hasattr(x, "id") and (callable(x.id) and x.id() or x.id) or hasattr(x, "__name__") and x.__name__ or x) for x in parents[:]])
    self.steps[-1]=aliasName

# hotfixes
ZPublisher.HTTPRequest.HTTPRequest.setAliasFolder=setAliasFolder
ZPublisher.HTTPRequest.HTTPRequest.setAliasName=setAliasName
